{************************************}
{*** Jednotka pro 3D Grafiku ********}
{*** c Dalibor Martiek *************}
{*** 30.3.2001 **********************}
{************************************}

unit Graph3d;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin;

const  { ** promtac metody - projection types **}
       ptParallel = 0;          {kosohl axonometrie}
       ptOrtho    = 1;          {kolm axonometrie}
       ptCenter   = 2;          {stedov promtn}
       ptSphere   = 3;          {promtn na kulovou plochu}
type
  TPixel           = array [1..2]      of Integer;
  T2DPoint         = array [1..2]      of Double;
  T3DPoint         = array [1..4]      of Double;
  TArrayOf3DPoints = array [0..800]    of T3DPoint;
  TMatrix          = array [1..4,1..4] of Double;
  TVector          = array [1..4]      of Double;
  TBox             = record
                       A,B,C,D,Ac,Bc,Cc,Dc:T3DPoint;
                     end;
//**** Pidal Jakub Stodola
  T33Matrix        = array [1..3,1..3] of Double;
//****
  TDraw3D = class(TForm)
    Panel: TPanel;
    Image: TImage;
    MemoryImage: TImage;
//****
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    LabelMouse: TLabel;
    SpinEdit1: TSpinEdit;
    CheckBoxAutoref: TCheckBox;
    SpinEdit2: TSpinEdit;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    SpinEdit3: TSpinEdit;
    StaticText6: TStaticText;
    ButtonRefresh: TButton;
//    procedure MemoryImageMouseDown(Sender: TObject; Button: TMouseButton;
//      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure ImageClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ButtonRefreshClick(Sender: TObject);
//****
  private
    { Private declarations }

  public
  // Pidal Jakub Stodola
//var
     moX, moY, moZ, moZrem: Double;
     TargetImage: ^TImage;
     SideViews: Boolean;
     ImagePainted, ImagePaintedPom: TBitmap;
     zadavani: integer;
  //***
    { Public declarations }
    {Barevn sloky}
    Red,Green,Blue   :Byte;
    {Typ promtn}
    ProjectionType   :Byte;
    {hly pozorovn}
    AlfaView,BetaView:Double;
    {Smr pohledu pozorovatele}
    DirectOfView     :TVector;
    {Smr. hly svtelnho zdroje}
    AlfaLight,BetaLight:Double;
    {Smr svtla}
    DirectOfLight     :TVector;
   {Vzdlenost pozorovatele}
    ObserverDistance :Double;
    {Msto pozorovn}
    ObserverPoint    :T3DPoint;
    {Hlavn paprsek}
    MajorRay         :TVector;
    {Velikost uivatelskch 2D jednotek ve svtovch souadnicch}
    Unit_X,Unit_Y    :Double;
    {Svtov souadnice uivatelskho 2D potku}
    O                :T2DPoint;
    {Body}
    A,B,C,D,Ac,Bc,Cc,Dc   :T3DPoint;
    {koeficienty prmtu 3D objektu do 2D}
    i1,i2,j1,j2,k1,k2,
    {uivatelsk rozmry kreslc 2D plochy}
    x1,x2,y1,y2,
    {funkn promnn a jejich kroky}
    x,y,z,hx,hy,hz,
    {parametr pro parametrickou kivku, jeho interval a krok}
    t,t1,t2,ht,r,r1,r2,hr,s,s1,s2,hs,
    {argument pro polrn souadnice, jeho interval a krok}
    fi,fi1,fi2,hfi      :Double;

    {pole bod pro kivky}
    P,Q                 :TArrayOf3DPoints;

    {***** svtov souadnice 2D *****}

    {Nastaven velikosti obrazu}
    Procedure InitImage(Width,Height:Integer);
    {Nastaven velikosti pamti pro obraz}
    Procedure InitMemoryImage(Width,Height:Integer);
    {nastaven barvy z barevnch sloek}
    Procedure ClearImage(Red,Green,Blue:byte);
    {Nastaven uivatelskch rozmr kreslc plochy}
    procedure Scale(x1,x2,y1,y2:Double);
    {Pepoet prvn uivatelsk souadnice na svtovou}
    function  XCoor(x:Double):integer;
    {Pepoet druh uivatelsk souadnice na svtovou}
    function  YCoor(y:Double):integer;
    {Sestroj bod ve svtovch souadnicch zadanou barvou}
    procedure PutPixel(X:TPixel;Red,Green,Blue:byte);
    {Zjist barvu bodu zadanho ve svtovch souadnicch}
    Procedure GetPixel(X:TPixel;var Red,Green,Blue:byte);
    {Sestroj seku ve svtovch souadnicch zadanou barvou}
    procedure Line2D(X,Y:TPixel;Red,Green,Blue:byte);
    {Sestroj seku v pamti ve svtovch souadnicch}
    procedure MemoryLine2D(X,Y:TPixel;Red,Green,Blue:byte);
    {Sestroj seku interpolac barvy ve svtovch souadnicch}
    procedure InterpolLine2D(X,Y:TPixel;RedX,GreenX,BlueX,
                                        RedY,GreenY,BlueY:byte);
    {Sestroj seku interpolac barvy pamti ve svtovch souadnicch}
    procedure MemoryInterpolLine2D(X,Y:TPixel;RedX,GreenX,BlueX,
                                              RedY,GreenY,BlueY:byte);
    {Sestroj trojhelnk ve svtovch souadnicch zadanou barvou}
    procedure Triangle2D(X,Y,Z:TPixel;Red,Green,Blue:byte);
    {Sestroj trojhelnk ve svtovch souadnicch vyplnn zadanou barvou}
    procedure FillTriangle2D(X,Y,Z:TPixel;Red,Green,Blue:byte);
   {Sestroj  drsn trojhelnk ve svtovch souadnicch vyplnn zadanou barvou}
    Procedure FillRoughTriangle2D(X,Y,Z:TPixel;Red,Green,Blue,Roughness:Byte;ColorDisp:Boolean);
     {Sestroj prhledn trojhelnk ve svtovch souadnicch vyplnn zadanou barvou}
    Procedure FillTranspTriangle2D(X,Y,Z:TPixel;Red,Green,Blue:Byte;Transparency:Double);
    {Sestroj trojhelnk interpolac barvy ve vrcholech ve svtovch souadnicch}

    procedure FillInterpolTriangle2D(X,Y,Z:TPixel;RedX,GreenX,BlueX,
                                                  RedY,GreenY,BlueY,
                                                  RedZ,GreenZ,BlueZ:byte);
   {Sestroj prhledn trojhelnk vyplnn interpolac barvy ve vrcholech}
   procedure FillInterpolTranspTriangle2D
                        (X,Y,Z:TPixel;RedX,GreenX,BlueX,
                                      RedY,GreenY,BlueY,
                                      RedZ,GreenZ,BlueZ:byte;Transparency:Double);

    {***** Promtac metody ********}

    {Prmt bodu z 3D do prmtny}
    procedure Projection(X:T3DPoint;var Xp:T2DPoint);
    {Prsek promtacho paprsku s rovinnou prmtnou}
    Procedure PlaneIntersect(X:T3DPoint;var pX:T3DPoint);
    {Prsek promtacho paprsku s kulovou prmtnou}
    Procedure SphereIntersect(X:T3DPoint;var pX:T3DPoint);
    {Nastaven smru pohledu pro paraleln projekci}
    procedure SetOrthoAxonProjection(Alfa,Beta:Double);
    {Nastaven stedu promtn pro centrln projekci}
    procedure SetCenterProjection(Alfa,Beta,ObserverDistance:Double;var ObserverPoint:T3DPoint);
    {Nastaven sfrick projekce}
    procedure SetSphereProjection(Alfa,Beta,ObserverDistance:Double;var ObserverPoint:T3DPoint);
    {Nastaven smru svtla}
    procedure SetDirectOfLight(AlfaLight,BetaLight:Double;var DirectOfLight:TVector);

    {***** Pomocn vpoty - ScanLine  3D *****}

    {Vektor uren dvma body}
    Procedure SetVector(X,Y:T3DPoint;var v:TVector);
    {Skalrn souin}
    Function ScalarProduct(u,v:TVector):Double;
    {Vektorov souin}
    Procedure VectorProduct(r,s:TVector;var t:TVector);
    {Velikost vektoru}
    Function Norm(u:TVector):Double;
    {Kosinus hlu vektor}
    function CosAngle(r,s:TVector):Double;

    {***** Konstrukce objekt v uivatelskch souadnicch - ScanLine  3D *****}

(*    {Sestroj rovnobku s osou x zadanou barvou}
    Procedure XAxis(x1,x2,y,z:Double;Red,Green,Blue:byte);
   {Sestroj rovnobku s osou y zadanou barvou}
    Procedure YAxis(y1,y2,x,z:Double;Red,Green,Blue:byte);
    {Sestroj rovnobku s osou z zadanou barvou}
    Procedure ZAxis(z1,z2,x,y:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou x zadanou barvou}
    Procedure GaugedXAxis(x1,x2,y,z:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou y zadanou barvou}
    procedure GaugedYAxis(y1,y2,x,z:Double;Red,Green,Blue:byte);
    {Sestroj cejchovanou rovnobku s osou y zadanou barvou}
    procedure GaugedZAxis(z1,z2,x,y:Double;Red,Green,Blue:byte);*)

    {Sestroj bod na uivatelskch souadnicch zadanou barvou}
    Procedure Put3DPoint(X:T3DPoint;Red,Green,Blue:byte);
    {Sestroj kek na uivatelskch souadnicch zadanou barvou}
    Procedure Cross(X:T3DPoint;Size,Red,Green,Blue:byte);
    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure Line(A,B:T3DPoint;Red,Green,Blue:byte);
     {Sestroj polygon prochzenc prvnmi n body zadanho pole zadanou barvou}
    procedure PolyLine(X:TArrayOf3DPoints;n:Word;Red,Green,Blue:byte);
    {Sestroj trojhelnk zadanou barvou}
    procedure Triangle(A,B,C:T3DPoint;Red,Green,Blue:byte);
    {Sestroj trojhelnk vyplnn zadanou barvou}
    procedure FillTriangle(A,B,C:T3DPoint;Red,Green,Blue:byte);
    {Sestroj drsn trojhelnk vyplnn zadanou barvou}
    procedure FillRoughTriangle(A,B,C:T3DPoint;Red,Green,Blue,Roughness:byte;ColorDisp:boolean);
    {Sestroj prhledn trojhelnk vyplnn zadanou barvou}
    procedure FillTranspTriangle(A,B,C:T3DPoint;Red,Green,Blue:byte;Transparency:Double);
    {Sestroj trojhelnk vyplnn interpolac barvy ve vrcholech}
    procedure FillInterpolTriangle(A,B,C:T3DPoint;RedA,GreenA,BlueA,
                                                    RedB,GreenB,BlueB,
                                                    RedC,GreenC,BlueC:byte);
    {Sestroj prhledn trojhelnk vyplnn interpolac barvy ve vrcholech}
    procedure FillInterpolTranspTriangle
                        (A,B,C:T3DPoint;RedA,GreenA,BlueA,
                                        RedB,GreenB,BlueB,
                                        RedC,GreenC,BlueC:byte;Transparency:Double);

    {***** uivatelsk souadnice - Canvas  3D  *****}

    {Sestroj seku v uivatelskch souadnicch zadanou barvou}
    procedure cvLine(A,B:T3DPoint;Red,Green,Blue:byte);
    {Sestroj polygon prochzenc prvnmi n body zadanho pole zadanou barvou}
    procedure cvPolyLine(X:TArrayOf3DPoints;n:Word;Red,Green,Blue:byte);
    {Sestroj hrany estistnu urenho vrcholy zadanou barvou}
    procedure cvBox(Box:TBox;Red,Green,Blue:byte);

   {**** nastaven matic zakladnich tansformac *****}

   {transformace bodu X matic Z do bodu X'}
    procedure TransOfPoint(X:T3DPoint;Z:TMatrix;var Xc:T3DPoint);
   {transformace trojhelnka ABC matic Z do trojhelnka A'B'C'}
    Procedure TransOfTriangle(A,B,C:T3DPoint;Z:TMatrix;var Ac,Bc,Cc:T3DPoint);

    procedure TransOfBox(Box1:TBox;Z:TMatrix;var Box2:TBox);
   {**** nastaven matic slozench transformac **********}
    {nsoben matic}
    Procedure Multip(M,N:TMatrix;var Result:TMatrix);
    {posunut o vektor v}
    Procedure Transl(V:TVector;var M:TMatrix);
   {otoen o hel alfa kolem osy X}
    Procedure RotX(Alfa:Double;var M:TMatrix);
   {otoen o hel alfa kolem osy Y}
    Procedure RotY(Beta:Double;var M:TMatrix);
   {otoen o hel alfa kolem osy Z}
    Procedure RotZ(Gamma:Double;var M:TMatrix);
   {stedov soumrnost se stedem v potku}
    procedure AxisSymX(var M:TMatrix);
    procedure AxisSymY(var M:TMatrix);
    procedure AxisSymZ(var M:TMatrix);
    procedure PlaneSymXY(var M:TMatrix);
    procedure PlaneSymYZ(var M:TMatrix);
    procedure PlaneSymXZ(var M:TMatrix);
    procedure OriginSym(var M:TMatrix);
    {rotace kolem obecn osy}
    procedure GenRot(A,B:T3DPoint;Alfa:Double;var M:TMatrix);

    {****** Pidal Jakub Stodola *****}
        procedure InvPlaneIntersect(ipX: T3DPoint; zc: Double ; var X: T3DPoint);
        procedure InvProjection(pX: T2DPoint;var ipX: T3DPoint);
//        Procedure Put3DPointMem(X:T3DPoint;Red,Green,Blue:byte);
//        procedure PutPixelMem(X:TPixel;Red,Green,Blue:byte);
        procedure InvSphereProjection(pX: T2DPoint;var ipX: T3DPoint);
        {een soustavy rovnic AX = b, kde A je matice 3*3}
        procedure Solve33GEM(A: T33Matrix; b: TVector; var X: T3DPoint);
     //   Procedure InitImage4(Width,Height:Integer);
        procedure Set_TargetImage;
    {****** -------------------  *****}
  end;  {TDraw3D Declaration}

var  Draw3D: TDraw3D;

implementation

uses Plochy_Unit1, ControlPointTable_Unit1;

{$R *.DFM}

Procedure TDraw3D.InitImage(Width,Height:Integer);
begin
   //   Panel.Align:=alNone;
   //   Panel.Width:=Width;
   //   Panel.Height:=Height;
      TargetImage^.Align:=alNone;
      TargetImage^.Picture.Bitmap.PixelFormat:=pf24bit;
      TargetImage^.Picture.Bitmap.Width:=Width;
      TargetImage^.Picture.Bitmap.Height:=Height;
      TargetImage^.Width:=Width;
      TargetImage^.Height:=Height;
      TargetImage^.Visible:=True;
end;

Procedure TDraw3D.InitMemoryImage(Width,Height:Integer);
begin
      MemoryImage.Align:=alNone;
      MemoryImage.Picture.Bitmap.PixelFormat:=pf24bit;
      MemoryImage.Picture.Bitmap.Width:=Width;
      MemoryImage.Picture.Bitmap.Height:=Height;
      MemoryImage.Width:=Width;
      MemoryImage.Height:=Height;
      MemoryImage.Visible:=False;
end;

Procedure TDraw3D.ClearImage(Red,Green,Blue:Byte);
var i,j,Adr:Integer;
    ScanRow: PByteArray;
begin
  With TargetImage^ do
  for j:=0 to Height-1 do
  begin
    ScanRow:=Picture.Bitmap.ScanLine[j];
    for i:=0 to Width-1 do
    begin
      Adr:=3*i;
      ScanRow[Adr]:=Blue;
      ScanRow[succ(Adr)]:=Green;
      ScanRow[succ(succ(Adr))]:=Red;
    end;
  end;
end;

Procedure TDraw3D.Scale(x1,x2,y1,y2:Double);
  begin
     Unit_X:= TargetImage^.Width/(x2-x1);
     Unit_Y:= TargetImage^.Height/(y2-y1);
     O[1]  := -x1*Unit_X;
     O[2]  :=  y2*Unit_Y;
  end;

function  TDraw3D.XCoor(x:Double):integer;
  begin
    XCoor:=Round(O[1]+Unit_X*x);
  end;

function  TDraw3D.YCoor(y:Double):integer;
  begin
     YCoor:=Round(O[2]-Unit_Y*y);
  end;

procedure TDraw3D.PutPixel(X:TPixel;Red,Green,Blue:Byte);
  var Adr:Integer;
      ScanRow: PByteArray;
  begin
      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[X[2]];
      Adr:=3*X[1];
      ScanRow[Adr]:=Blue;
      ScanRow[succ(Adr)]:=Green;
      ScanRow[succ(succ(Adr))]:=Red;
  end;

procedure TDraw3D.GetPixel(X:TPixel;var Red,Green,Blue:Byte);
  var Adr:Integer;
      ScanRow: PByteArray;
  begin
      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[X[2]];
      Adr:=3*X[1];
      Blue:=ScanRow[Adr];
      Green:=ScanRow[succ(Adr)];
      Red:=ScanRow[succ(succ(Adr))];
  end;

procedure TDraw3D.Line2D(X,Y:TPixel;Red,Green,Blue:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
      ScanRow: PByteArray;
  Begin
  With TargetImage^ do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  ScanRow[Adr]:=Blue;
  ScanRow[succ(Adr)]:=Green;
  ScanRow[succ(succ(Adr))]:=Red;
  if Dx=0 then
           if Dy>0 then Position:=1
                   else Position:=2
          else
           if Dy=0 then Position:=9
            else
            if Dy=Dx then Position:=3
                    else
                     if Dy=-Dx then Position:=4
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=5
                                                 else Position:=6
                                        else
                                         if -Dy>Dx then Position:=7
                                                   else Position:=8;
 Case Position of
  1: For i:=succ(X[2]) to Y[2] do
            begin
              ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[i];
              Adr:=3*M[1];
              ScanRow[Adr]:=Blue;
              ScanRow[succ(Adr)]:=Green;
              ScanRow[succ(succ(Adr))]:=Red;
            end;
  2: For i:=pred(X[2]) downto Y[2] do
            begin
              ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[i];
              Adr:=3*M[1];
              ScanRow[Adr]:=Blue;
              ScanRow[succ(Adr)]:=Green;
              ScanRow[succ(succ(Adr))]:=Red;
            end;
  3: For i:=succ(X[1]) to Y[1] do
            begin
              inc(M[2]);
              ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              ScanRow[Adr]:=Blue;
              ScanRow[succ(Adr)]:=Green;
              ScanRow[succ(succ(Adr))]:=Red;
            end;
  4: For i:=succ(X[1]) to Y[1] do
           begin
             dec(M[2]);
             ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             ScanRow[Adr]:=Blue;
             ScanRow[succ(Adr)]:=Green;
             ScanRow[succ(succ(Adr))]:=Red;
           end;
  5: begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  6: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
       end;
      end;
  7: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  8: begin
       Dy:=-Dy;ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
   9:begin
      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       Adr:=3*i;
       ScanRow[Adr]:=Blue;
       ScanRow[succ(Adr)]:=Green;
       ScanRow[succ(succ(Adr))]:=Red;
      end;
    end;
  end;
end;      {Line2D}

procedure TDraw3D.MemoryLine2D(X,Y:TPixel;Red,Green,Blue:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
      ScanRow: PByteArray;
  Begin
  With MemoryImage do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  ScanRow[Adr]:=Blue;
  ScanRow[succ(Adr)]:=Green;
  ScanRow[succ(succ(Adr))]:=Red;
  if Dx=0 then
           if Dy>0 then Position:=1
                   else Position:=2
          else
           if Dy=0 then Position:=9
            else
            if Dy=Dx then Position:=3
                    else
                     if Dy=-Dx then Position:=4
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=5
                                                 else Position:=6
                                        else
                                         if -Dy>Dx then Position:=7
                                                   else Position:=8;
 Case Position of
  1: For i:=succ(X[2]) to Y[2] do
            begin
              ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[i];
              Adr:=3*M[1];
              ScanRow[Adr]:=Blue;
              ScanRow[succ(Adr)]:=Green;
              ScanRow[succ(succ(Adr))]:=Red;
            end;
  2: For i:=pred(X[2]) downto Y[2] do
            begin
              ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[i];
              Adr:=3*M[1];
              ScanRow[Adr]:=Blue;
              ScanRow[succ(Adr)]:=Green;
              ScanRow[succ(succ(Adr))]:=Red;
            end;
  3: For i:=succ(X[1]) to Y[1] do
            begin
              inc(M[2]);
              ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              ScanRow[Adr]:=Blue;
              ScanRow[succ(Adr)]:=Green;
              ScanRow[succ(succ(Adr))]:=Red;
            end;
  4: For i:=succ(X[1]) to Y[1] do
           begin
             dec(M[2]);
             ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             ScanRow[Adr]:=Blue;
             ScanRow[succ(Adr)]:=Green;
             ScanRow[succ(succ(Adr))]:=Red;
           end;
  5: begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  6: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
       end;
      end;
  7: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
  8: begin
       Dy:=-Dy;ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        ScanRow[Adr]:=Blue;
        ScanRow[succ(Adr)]:=Green;
        ScanRow[succ(succ(Adr))]:=Red;
      end;
     end;
   9:begin
      ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       Adr:=3*i;
       ScanRow[Adr]:=Blue;
       ScanRow[succ(Adr)]:=Green;
       ScanRow[succ(succ(Adr))]:=Red;
      end;
    end;
  end;
end;      {MemoryLine2D}

procedure TDraw3D.InterpolLine2D(X,Y:TPixel;RedX,GreenX,BlueX,RedY,GreenY,BlueY:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
      StepR,StepG,StepB,R,G,B:Single;
      ScanRow: PByteArray;
  Begin
  With TargetImage^ do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
             Position:=RedX;  RedX:=RedY;    RedY:=Position;
             Position:=GreenX;GreenX:=GreenY;GreenY:=Position;
             Position:=BlueX; BlueX:=BlueY;  BlueY:=Position;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  ScanRow[Adr]:=BlueX;
  ScanRow[succ(Adr)]:=GreenX;
  ScanRow[succ(succ(Adr))]:=RedX;
  if (Dx=0) and (Dy=0) then exit;
  if abs(Dx)>abs(Dy) then begin
                 StepR:=(RedY-RedX)/DX;
                 StepG:=(GreenY-GreenX)/DX;
                 StepB:=(BlueY-BlueX)/DX;
                end
           else begin
                 StepR:=(RedY-RedX)/abs(DY);
                 StepG:=(GreenY-GreenX)/abs(DY);
                 StepB:=(BlueY-BlueX)/abs(DY);
                end;
  if Dx=0 then
           if Dy>0 then Position:=1
                   else Position:=2
          else
           if Dy=0 then Position:=9
            else
            if Dy=Dx then Position:=3
                    else
                     if Dy=-Dx then Position:=4
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=5
                                                 else Position:=6
                                        else
                                         if -Dy>Dx then Position:=7
                                                   else Position:=8;
 R:=RedX;G:=GreenX;B:=BlueX;
 Case Position of
  1:   For i:=succ(X[2]) to Y[2] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[i];
              Adr:=3*M[1];
              ScanRow[Adr]:=Round(B);
              ScanRow[succ(Adr)]:=Round(G);
              ScanRow[succ(succ(Adr))]:=Round(R);
            end;
 2:  For i:=pred(X[2]) downto Y[2] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[i];
              Adr:=3*M[1];
              ScanRow[Adr]:=Round(B);
              ScanRow[succ(Adr)]:=Round(G);
              ScanRow[succ(succ(Adr))]:=Round(R);
            end;
  3: For i:=succ(X[1]) to Y[1] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              inc(M[2]);
              ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              ScanRow[Adr]:=Round(B);
              ScanRow[succ(Adr)]:=Round(G);
              ScanRow[succ(succ(Adr))]:=Round(R);
            end;
  4: For i:=succ(X[1]) to Y[1] do
           begin
             R:=R+StepR;G:=G+StepG;B:=B+StepB;
             dec(M[2]);
             ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             ScanRow[Adr]:=Round(B);
             ScanRow[succ(Adr)]:=Round(G);
             ScanRow[succ(succ(Adr))]:=Round(R);
           end;
  5: begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  6: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
       end;
      end;
  7: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  8: begin
       Dy:=-Dy;ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
   9:begin
      ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       R:=R+StepR;G:=G+StepG;B:=B+StepB;
       Adr:=3*i;
       ScanRow[Adr]:=Round(B);
       ScanRow[succ(Adr)]:=Round(G);
       ScanRow[succ(succ(Adr))]:=Round(R);
      end;
    end;
  end;
end;       {InterpolLine2D}

procedure TDraw3D.MemoryInterpolLine2D(X,Y:TPixel;RedX,GreenX,BlueX,RedY,GreenY,BlueY:Byte);
  var p,p1,p2,Dx,Dy,i       :Integer;
      M                     :TPixel;
      Position              :Byte;
      Adr                   :Integer;
      StepR,StepG,StepB,R,G,B:Single;
      ScanRow:PByteArray;
  Begin
  if (Y[1]=667) and (Y[2]=1217) and (X[1]=667) and (X[2]=1325)
               then
                 Adr:=0;
  With TargetImage^ do
  if (X[1]<0) or (X[1]>=Width) or (X[2]<0) or (X[2]>=Height) or
     (Y[1]<0) or (Y[1]>=Width) or (Y[2]<0) or (Y[2]>=Height) then exit;
  Dx:=Y[1]-X[1];
  if Dx<0 then
       begin
             p:=X[1];X[1]:=Y[1];Y[1]:=p;
             p:=X[2];X[2]:=Y[2];Y[2]:=p;
             Dx:=-Dx;
             Position:=RedX;  RedX:=RedY;    RedY:=Position;
             Position:=GreenX;GreenX:=GreenY;GreenY:=Position;
             Position:=BlueX; BlueX:=BlueY;  BlueY:=Position;
       end;
  Dy:=Y[2]-X[2];M[1]:=X[1];M[2]:=X[2];
  ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
  Adr:=3*M[1];
  ScanRow[Adr]:=BlueX;
  ScanRow[succ(Adr)]:=GreenX;
  ScanRow[succ(succ(Adr))]:=RedX;
  if (Dx=0) and (Dy=0) then exit;                                {jedin bod}
  {if (Dx=0) then
              Adr:=succ(Adr)-1;}
  if abs(Dx)>abs(Dy) then begin
                 StepR:=(RedY-RedX)/DX;
                 StepG:=(GreenY-GreenX)/DX;
                 StepB:=(BlueY-BlueX)/DX;
                end
           else begin
                 StepR:=(RedY-RedX)/abs(DY);
                 StepG:=(GreenY-GreenX)/abs(DY);
                 StepB:=(BlueY-BlueX)/Abs(DY);
                end;
  if Dx=0 then
           if Dy>0 then Position:=1                           {svisle nahoru}
                   else Position:=2                             {svisle dolu}
          else
           if Dy=0 then Position:=3                           {zleva doprava}
            else
            if Dy=Dx then Position:=4                                   {k=1}
                    else
                     if Dy=-Dx then Position:=5                        {k=-1}
                               else
                               if Dy>0 then
                                       if Dy>Dx then Position:=6        {k>1}
                                                else Position:=7      {0<k<1}
                                        else
                                         if -Dy>Dx then Position:=8    {k<-1}
                                                   else Position:=9; {-1<k<0}
Case Position of
  {svisle nahoru}
  1: begin
     Adr:=3*M[1];R:=RedX;G:=GreenX;B:=BlueX;
     For i:=succ(X[2]) to Y[2] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[i];
              ScanRow[Adr]:=Round(B);
              ScanRow[succ(Adr)]:=Round(G);
              ScanRow[succ(succ(Adr))]:=Round(R);
            end;
     end;
  {svisle dol}
  2: begin
      Adr:=3*M[1];R:=RedX;G:=GreenX;B:=BlueX;
      For i:=pred(X[2]) downto Y[2] do
            begin
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[i];
              ScanRow[Adr]:=Round(B);
              ScanRow[succ(Adr)]:=Round(G);
              ScanRow[succ(succ(Adr))]:=Round(R);
            end;
     end;
   {zleva doprava}
   3:begin
      R:=RedX;G:=GreenX;B:=BlueX;
      ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
      For i:=succ(X[1]) to Y[1] do
      begin
       R:=R+StepR;G:=G+StepG;B:=B+StepB;
       Adr:=3*i;
       ScanRow[Adr]:=Round(B);
       ScanRow[succ(Adr)]:=Round(G);
       ScanRow[succ(succ(Adr))]:=Round(R);
      end;
    end;
   {k=1}
   4:begin
     R:=RedX;G:=GreenX;B:=BlueX;
     For i:=succ(X[1]) to Y[1] do
            begin
             inc(M[2]);
              R:=R+StepR;G:=G+StepG;B:=B+StepB;
              ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
              Adr:=3*i;
              ScanRow[Adr]:=Round(B);
              ScanRow[succ(Adr)]:=Round(G);
              ScanRow[succ(succ(Adr))]:=Round(R);
            end;
     end;
   {k=-1}
   5: begin
      R:=RedX;G:=GreenX;B:=BlueX;
      For i:=succ(X[1]) to Y[1] do
           begin
             dec(M[2]);
             R:=R+StepR;G:=G+StepG;B:=B+StepB;
             ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
             Adr:=3*i;
             ScanRow[Adr]:=Round(B);
             ScanRow[succ(Adr)]:=Round(G);
             ScanRow[succ(succ(Adr))]:=Round(R);
           end;
      end;
   {k>1}
   6:begin
       R:=RedX;G:=GreenX;B:=BlueX;
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<Y[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  {0<k<1}
  7: begin
       R:=RedX;G:=GreenX;B:=BlueX;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
       end;
      end;
  {k<-1}
  8: begin
       R:=RedX;G:=GreenX;B:=BlueX;
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>Y[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  {-1<k<0}
  9: begin
       R:=RedX;G:=GreenX;B:=BlueX;
       Dy:=-Dy;ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<Y[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      ScanRow:=MemoryImage.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        Adr:=3*M[1];
        R:=R+StepR;G:=G+StepG;B:=B+StepB;
        ScanRow[Adr]:=Round(B);
        ScanRow[succ(Adr)]:=Round(G);
        ScanRow[succ(succ(Adr))]:=Round(R);
      end;
     end;
  end;
end;       {MemoryInterpolLine2D}

Procedure TDraw3D.Triangle2D(X,Y,Z:TPixel;Red,Green,Blue:Byte);
  begin
    Line2D(X,Y,Red,Green,Blue);
    Line2D(Y,Z,Red,Green,Blue);
    Line2D(X,Z,Red,Green,Blue);
  end;

Procedure TDraw3D.FillTriangle2D(X,Y,Z:TPixel;Red,Green,Blue:Byte);
  Const ProvisR=254;ProvisG=254;ProvisB=254;
  var i,j,h1,h2,MinI,MaxI,MinJ,MaxJ,Adr:Integer;
      BorderLine                       :Boolean;
       ScanRow: PByteArray;
  begin
    MinI:=X[1];MaxI:=X[1];MinJ:=X[2];MaxJ:=X[2];
    if MinI>Y[1] then MinI:=Y[1] else if MaxI<Y[1] then MaxI:=Y[1];
    if MinJ>Y[2] then MinJ:=Y[2] else if MaxJ<Y[2] then MaxJ:=Y[2];
    if MinI>Z[1] then MinI:=Z[1] else if MaxI<Z[1] then MaxI:=Z[1];
    if MinJ>Z[2] then MinJ:=Z[2] else if MaxJ<Z[2] then MaxJ:=Z[2];
    if (MinI<0) or (MaxI>=TargetImage^.Picture.Bitmap.Width) then exit;
    if (MinJ<0) or (MaxJ>=TargetImage^.Picture.Bitmap.Height) then exit;
    Line2D(X,Y,ProvisR,ProvisG,ProvisB);
    Line2D(Y,Z,ProvisR,ProvisG,ProvisB);
    Line2D(X,Z,ProvisR,ProvisG,ProvisB);
    For j:=MinJ to MaxJ do
    begin
       ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[j];
       i:=Pred(MinI);
       Repeat
        inc(i);Adr:=3*i;
        BorderLine:=(ScanRow[Adr]=ProvisB) and (ScanRow[succ(Adr)]=ProvisG) and
                    (ScanRow[succ(succ(Adr))]=ProvisR)
       Until (i=MaxI) or BorderLine;
       if BorderLine
         then begin
               h1:=i;
               i:=succ(MaxI);
               Repeat
                 dec(i);Adr:=3*i;
                 BorderLine:=(ScanRow[Adr]=ProvisB) and (ScanRow[succ(Adr)]=ProvisG) and
                             (ScanRow[succ(succ(Adr))]=ProvisR)
               Until (i=h1) or BorderLine;
               h2:=i;
               For i:=h1 to h2 do
               begin
                 Adr:=3*i;
                 ScanRow[Adr]:=Blue;
                 ScanRow[succ(Adr)]:=Green;
                 ScanRow[succ(succ(Adr))]:=Red;
               end;
             end;
        end;
  end;         {FillTriangle2D}

Procedure TDraw3D.FillRoughTriangle2D(X,Y,Z:TPixel;Red,Green,Blue,Roughness:Byte;ColorDisp:Boolean);
  Const ProvisR=254;ProvisG=254;ProvisB=254;
  var i,j,h1,h2,MinI,MaxI,MinJ,MaxJ,Adr:Integer;
      BorderLine                       :Boolean;
      ScanRow                          :PByteArray;
      Rough,R,G,B                      :Byte;
      Factor                           :Double;
  begin
    Rough:=Trunc(Roughness*2.55);
    MinI:=X[1];MaxI:=X[1];MinJ:=X[2];MaxJ:=X[2];
    if MinI>Y[1] then MinI:=Y[1] else if MaxI<Y[1] then MaxI:=Y[1];
    if MinJ>Y[2] then MinJ:=Y[2] else if MaxJ<Y[2] then MaxJ:=Y[2];
    if MinI>Z[1] then MinI:=Z[1] else if MaxI<Z[1] then MaxI:=Z[1];
    if MinJ>Z[2] then MinJ:=Z[2] else if MaxJ<Z[2] then MaxJ:=Z[2];
    if (MinI<0) or (MaxI>=TargetImage^.Picture.Bitmap.Width) then exit;
    if (MinJ<0) or (MaxJ>=TargetImage^.Picture.Bitmap.Height) then exit;
    Line2D(X,Y,ProvisR,ProvisG,ProvisB);
    Line2D(Y,Z,ProvisR,ProvisG,ProvisB);
    Line2D(X,Z,ProvisR,ProvisG,ProvisB);
    For j:=MinJ to MaxJ do
    begin
       ScanRow:=TargetImage^.Picture.Bitmap.ScanLine[j];
       i:=Pred(MinI);
       Repeat
        inc(i);Adr:=3*i;
        BorderLine:=(ScanRow[Adr]=ProvisB) and (ScanRow[succ(Adr)]=ProvisG) and
                    (ScanRow[succ(succ(Adr))]=ProvisR)
       Until (i=MaxI) or BorderLine;
       if BorderLine
         then begin
               h1:=i;
               i:=succ(MaxI);
               Repeat
                 dec(i);Adr:=3*i;
                 BorderLine:=(ScanRow[Adr]=ProvisB) and (ScanRow[succ(Adr)]=ProvisG) and
                             (ScanRow[succ(succ(Adr))]=ProvisR)
               Until (i=h1) or BorderLine;
               h2:=i;
               For i:=h1 to h2 do
               begin
                 Factor:=(0.5-Random)*Rough;
                 if Red+Factor>255 then R:=255 else if Red+FActor<0 then R:=0 else R:=Trunc(Red+Factor);
                 if ColorDisp then  Factor:=(0.5-Random)*Rough;
                 if Green+Factor>255 then G:=255 else if Green+FActor<0 then G:=0 else G:=Trunc(Green+Factor);
                 if ColorDisp then  Factor:=(0.5-Random)*Rough;
                 if Blue+Factor>255 then B:=255 else if Blue+FActor<0 then B:=0 else B:=Trunc(Blue+Factor);
                 Adr:=3*i;
                 ScanRow[Adr]:=B;
                 ScanRow[succ(Adr)]:=G;
                 ScanRow[succ(succ(Adr))]:=R;
               end;
             end;
        end;
  end;         {FillRoughTriangle2D}

Procedure TDraw3D.FillTranspTriangle2D(X,Y,Z:TPixel;Red,Green,Blue:Byte;Transparency:Double);
 Const ProvisR=254;ProvisG=254;ProvisB=254;
 var i,j,MinI,MaxI,MinJ,MaxJ,Adr:Integer;
      BorderLine                       :Boolean;
      MemoryScanRow,ScanRow            :PByteArray;
      M,N                              :TPixel;
  begin
    MinI:=X[1];MaxI:=X[1];MinJ:=X[2];MaxJ:=X[2];
    if MinI>Y[1] then MinI:=Y[1] else if MaxI<Y[1] then MaxI:=Y[1];
    if MinJ>Y[2] then MinJ:=Y[2] else if MaxJ<Y[2] then MaxJ:=Y[2];
    if MinI>Z[1] then MinI:=Z[1] else if MaxI<Z[1] then MaxI:=Z[1];
    if MinJ>Z[2] then MinJ:=Z[2] else if MaxJ<Z[2] then MaxJ:=Z[2];
    if (MinI<0) or (MaxI>=MemoryImage.Picture.Bitmap.Width) then exit;
    if (MinJ<0) or (MaxJ>=MemoryImage.Picture.Bitmap.Height) then exit;
    MemoryLine2D(X,Y,ProvisR,ProvisG,ProvisB);
    MemoryLine2D(Y,Z,ProvisR,ProvisG,ProvisB);
    MemoryLine2D(X,Z,ProvisR,ProvisG,ProvisB);
    For j:=MinJ to MaxJ do
    begin
       MemoryScanRow:=MemoryImage.Picture.Bitmap.ScanLine[j];
             ScanRow:=      TargetImage^.Picture.Bitmap.ScanLine[j];
       i:=pred(MinI);
       Repeat
        inc(i);Adr:=3*i;
        BorderLine:=(MemoryScanRow[Adr]=ProvisB) and (MemoryScanRow[succ(Adr)]=ProvisG) and
                    (MemoryScanRow[succ(succ(Adr))]=ProvisR);
       Until (i=MaxI) or BorderLine;
       if BorderLine
         then begin
               M[1]:=i;M[2]:=j;
               i:=succ(MaxI);
               Repeat
                 dec(i);Adr:=3*i;
                 BorderLine:=(MemoryScanRow[Adr]=ProvisB) and (MemoryScanRow[succ(Adr)]=ProvisG) and
                        (MemoryScanRow[succ(succ(Adr))]=ProvisR);
               Until (i=M[1]) or BorderLine;
               N[1]:=i;N[2]:=j;
               For i:=M[1] to N[1] do
                 begin
                   Adr:=3*i;
                   ScanRow[Adr]:=Round((1-Transparency)*Blue+Transparency*ScanRow[Adr]);
                   ScanRow[succ(Adr)]:=Round((1-Transparency)*Green+Transparency*ScanRow[succ(Adr)]);
                   ScanRow[succ(succ(Adr))]:=Round((1-Transparency)*Red+Transparency*ScanRow[succ(succ(Adr))]);
                   MemoryScanRow[Adr]:=255;
                   MemoryScanRow[succ(Adr)]:=255;
                   MemoryScanRow[succ(succ(Adr))]:=255;
                 end;
             end;
       end;
 end;                  {FillTranspTriangle2D}

Procedure TDraw3D.FillInterpolTriangle2D(X,Y,Z:TPixel;RedX,GreenX,BlueX,
                                                      RedY,GreenY,BlueY,
                                                      RedZ,GreenZ,BlueZ:Byte);
 Const ProvisR=254;ProvisG=254;ProvisB=254;
  var i,j,MinI,MaxI,MinJ,MaxJ,Adr:Integer;
      BorderLine                       :Boolean;
      MemoryScanRow                    :PByteArray;
      R1,G1,B1,R2,G2,B2                :Byte;
      M,N                              :TPixel;
  begin

    MinI:=X[1];MaxI:=X[1];MinJ:=X[2];MaxJ:=X[2];
    if MinI>Y[1] then MinI:=Y[1] else if MaxI<Y[1] then MaxI:=Y[1];
    if MinJ>Y[2] then MinJ:=Y[2] else if MaxJ<Y[2] then MaxJ:=Y[2];
    if MinI>Z[1] then MinI:=Z[1] else if MaxI<Z[1] then MaxI:=Z[1];
    if MinJ>Z[2] then MinJ:=Z[2] else if MaxJ<Z[2] then MaxJ:=Z[2];
    if (MinI<0) or (MaxI>=MemoryImage.Picture.Bitmap.Width) then exit;
    if (MinJ<0) or (MaxJ>=MemoryImage.Picture.Bitmap.Height) then exit;
    MemoryLine2D(X,Y,ProvisR,ProvisG,ProvisB);
    MemoryLine2D(Y,Z,ProvisR,ProvisG,ProvisB);
    MemoryLine2D(X,Z,ProvisR,ProvisG,ProvisB);
    InterpolLine2D(X,Y,RedX,GreenX,BlueX,RedY,GreenY,BlueY);
    InterpolLine2D(Y,Z,RedY,GreenY,BlueY,RedZ,GreenZ,BlueZ);
    InterpolLine2D(X,Z,RedX,GreenX,BlueX,RedZ,GreenZ,BlueZ);
    For j:=MinJ to MaxJ do
    begin
       MemoryScanRow:=MemoryImage.Picture.Bitmap.ScanLine[j];
       i:=pred(MinI);
       Repeat
        inc(i);Adr:=3*i;
        BorderLine:=(MemoryScanRow[Adr]=ProvisB) and (MemoryScanRow[succ(Adr)]=ProvisG) and
                    (MemoryScanRow[succ(succ(Adr))]=ProvisR)
       Until (i=MaxI) or BorderLine;
       if BorderLine
         then begin
               M[1]:=i;M[2]:=j;
               i:=succ(MaxI);
               Repeat
                 dec(i);Adr:=3*i;
                 BorderLine:=(MemoryScanRow[Adr]=ProvisB) and (MemoryScanRow[succ(Adr)]=ProvisG) and
                             (MemoryScanRow[succ(succ(Adr))]=ProvisR)
               Until (i=M[1]) or BorderLine;
               N[1]:=i;N[2]:=J;
               GetPixel(M,R1,G1,B1);GetPixel(N,R2,G2,B2);
               InterpolLine2D(M,N,R1,G1,B1,R2,G2,B2);
             end;
    end;
    MemoryLine2D(X,Y,255,255,255);
    MemoryLine2D(Y,Z,255,255,255);
    MemoryLine2D(X,Z,255,255,255);
  end;                  {FillInterpolTriangle2D}

Procedure TDraw3D.FillInterpolTranspTriangle2D(X,Y,Z:TPixel;RedX,GreenX,BlueX,
                                                      RedY,GreenY,BlueY,
                                                      RedZ,GreenZ,BlueZ:Byte;Transparency:Double);
  var i,j,MinI,MaxI,MinJ,MaxJ,Adr:Integer;
      BorderLine                       :Boolean;
      MemoryScanRow,ScanRow            :PByteArray;
      R1,G1,B1,R2,G2,B2                :Byte;
      M,N                              :TPixel;
  begin
    MinI:=X[1];MaxI:=X[1];MinJ:=X[2];MaxJ:=X[2];
    if MinI>Y[1] then MinI:=Y[1] else if MaxI<Y[1] then MaxI:=Y[1];
    if MinJ>Y[2] then MinJ:=Y[2] else if MaxJ<Y[2] then MaxJ:=Y[2];
    if MinI>Z[1] then MinI:=Z[1] else if MaxI<Z[1] then MaxI:=Z[1];
    if MinJ>Z[2] then MinJ:=Z[2] else if MaxJ<Z[2] then MaxJ:=Z[2];
    if (MinI<0) or (MaxI>=MemoryImage.Picture.Bitmap.Width) then exit;
    if (MinJ<0) or (MaxJ>=MemoryImage.Picture.Bitmap.Height) then exit;
    MemoryInterpolLine2D(X,Y,RedX,GreenX,BlueX,RedY,GreenY,BlueY);
    MemoryInterpolLine2D(Y,Z,RedY,GreenY,BlueY,RedZ,GreenZ,BlueZ);
    MemoryInterpolLine2D(X,Z,RedX,GreenX,BlueX,RedZ,GreenZ,BlueZ);
    For j:=MinJ to MaxJ do
    begin
       MemoryScanRow:=MemoryImage.Picture.Bitmap.ScanLine[j];
             ScanRow:=      TargetImage^.Picture.Bitmap.ScanLine[j];
       i:=pred(MinI);
       Repeat
        inc(i);Adr:=3*i;
        BorderLine:=(MemoryScanRow[Adr]<>255) or (MemoryScanRow[succ(Adr)]<>255) or
                    (MemoryScanRow[succ(succ(Adr))]<>255)
       Until (i=MaxI) or BorderLine;
       if BorderLine
         then begin
               M[1]:=i;M[2]:=j;
               i:=succ(MaxI);
               Repeat
                 dec(i);Adr:=3*i;
                 BorderLine:=(MemoryScanRow[Adr]<>255) or (MemoryScanRow[succ(Adr)]<>255) or
                             (MemoryScanRow[succ(succ(Adr))]<>255)
               Until (i=M[1]) or BorderLine;
               N[1]:=i;N[2]:=j;
               Adr:=3*M[1];
               B1:=MemoryScanRow[Adr];
               G1:=MemoryScanRow[succ(Adr)];
               R1:=MemoryScanRow[succ(succ(Adr))];
               Adr:=3*N[1];
               B2:=MemoryScanRow[Adr];
               G2:=MemoryScanRow[succ(Adr)];
               R2:=MemoryScanRow[succ(succ(Adr))];
               MemoryInterpolLine2D(M,N,R1,G1,B1,R2,G2,B2);
               For i:=M[1] to N[1] do
                 begin
                   Adr:=3*i;
                   ScanRow[Adr]:=Round((1-Transparency)*MemoryScanRow[Adr]+Transparency*ScanRow[Adr]);
                   ScanRow[succ(Adr)]:=Round((1-Transparency)*MemoryScanRow[succ(Adr)]+Transparency*ScanRow[succ(Adr)]);
                   ScanRow[succ(succ(Adr))]:=Round((1-Transparency)*MemoryScanRow[succ(succ(Adr))]+Transparency*ScanRow[succ(succ(Adr))]);
                   MemoryScanRow[Adr]:=255;
                   MemoryScanRow[succ(Adr)]:=255;
                   MemoryScanRow[succ(succ(Adr))]:=255;
{                   if Pomalu then
                       begin
                          TargetImage^.Repaint;
                          Application.ProcessMessages;
                       end;}
                 end;
             end;
       end;
 end;                  {FillInterpolTranspTriangle2D}

procedure TDraw3D.Projection(X:T3DPoint;var Xp:T2DPoint);
  begin
    Xp[1]:=i1*X[1]+j1*X[2]+k1*X[3];
    Xp[2]:=i2*X[1]+j2*X[2]+k2*X[3];
  end;

procedure TDraw3D.SetOrthoAxonProjection(Alfa,Beta:Double);
  var u,v                :TVector;
      SinAlfa,i,j,
      CosGamma,CosDelta,PomAlfa,PomBeta:Double;
      O,S,X,Y,Z          :T3DPoint;

  begin
  ProjectionType:=ptOrtho;
  PomAlfa:=Alfa;PomBeta:=Beta;
  if PomAlfa>90 then PomAlfa:=PomAlfa-90;
  if PomAlfa>90 then PomAlfa:=PomAlfa-90;
  PomAlfa:=Pi*PomAlfa/180;PomBeta:=pi*PomBeta/180;
  S[1]:=cos(PomAlfa)*cos(PomBeta);S[2]:=sin(PomAlfa)*cos(PomBeta);S[3]:=sin(PomBeta);
  O[1]:=0;O[2]:=0;O[3]:=0;
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  X[1]:=1/S[1];X[2]:=0;     X[3]:=0;
  Y[1]:=0;     Y[2]:=1/S[2];Y[3]:=0;
  Z[1]:=0;     Z[2]:=0;     Z[3]:=1/S[3];
  SetVector(S,X,u);SetVector(S,Z,v);
  CosGamma:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(S,Y,u);SetVector(S,Z,v);
  CosDelta:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(X,O,u);SetVector(X,S,v);
  i:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(Y,O,u);SetVector(Y,S,v);
  j:=ScalarProduct(u,v)/Norm(u)/Norm(v);
//  SetVector(Z,O,u);SetVector(Z,S,v);
  i1:=-i*sqrt(1-CosGamma*CosGamma);i2:=i*CosGamma;
  j1:=j*sqrt(1-CosDelta*CosDelta);j2:=j*CosDelta;
  k1:=0;                          k2:=cos(PomBeta);
  if Alfa>90 then
  begin
  S[1]:=cos(Alfa*pi/180)*cos(Beta*pi/180);S[2]:=sin(Alfa*pi/180)*cos(Beta*pi/180);S[3]:=sin(Beta*pi/180);
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  if Alfa<270 then
  Repeat
    Alfa:=Alfa-90;
    begin
    sinAlfa:=i1;i1:= j1;j1:=SinAlfa;
    sinAlfa:=i2;i2:=j2;j2:=SinAlfa;
    i1:=-i1;i2:=-i2;
    end;
   Until Alfa<90
   else begin
         i1:= -i1;j2:=-j2;
        end;
  end;
end;

Procedure TDraw3D.SetCenterProjection(Alfa,Beta,ObserverDistance:Double;var ObserverPoint:T3DPoint);
var u,v                :TVector;
      SinAlfa,i,j,
      CosGamma,CosDelta,PomAlfa,PomBeta:Double;
      O,S,X,Y,Z          :T3DPoint;
begin
  ProjectionType:=ptCenter;
  ObserverPoint[1]:=ObserverDistance*cos(Alfa*pi/180)*cos(Beta*pi/180);
  ObserverPoint[2]:=ObserverDistance*sin(Alfa*pi/180)*cos(Beta*pi/180);
  ObserverPoint[3]:=ObserverDistance*sin(Beta*pi/180);
  PomAlfa:=Alfa;PomBeta:=Beta;
  if PomAlfa>90 then PomAlfa:=PomAlfa-90;
  if PomAlfa>90 then PomAlfa:=PomAlfa-90;
  PomAlfa:=Pi*PomAlfa/180;PomBeta:=pi*PomBeta/180;
  S[1]:=cos(PomAlfa)*cos(PomBeta);S[2]:=sin(PomAlfa)*cos(PomBeta);S[3]:=sin(PomBeta);
  O[1]:=0;O[2]:=0;O[3]:=0;
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  X[1]:=1/S[1];X[2]:=0;     X[3]:=0;
  Y[1]:=0;     Y[2]:=1/S[2];Y[3]:=0;
  Z[1]:=0;     Z[2]:=0;     Z[3]:=1/S[3];
  SetVector(S,X,u);SetVector(S,Z,v);
  CosGamma:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(S,Y,u);SetVector(S,Z,v);
  CosDelta:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(X,O,u);SetVector(X,S,v);
  i:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(Y,O,u);SetVector(Y,S,v);
  j:=ScalarProduct(u,v)/Norm(u)/Norm(v);
//  SetVector(Z,O,u);SetVector(Z,S,v);
  i1:=-i*sqrt(1-CosGamma*CosGamma);i2:=i*CosGamma;
  j1:=j*sqrt(1-CosDelta*CosDelta);j2:=j*CosDelta;
  k1:=0;                          k2:=cos(PomBeta);
  if Alfa>90 then
  begin
  S[1]:=cos(Alfa*pi/180)*cos(Beta*pi/180);S[2]:=sin(Alfa*pi/180)*cos(Beta*pi/180);S[3]:=sin(Beta*pi/180);
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  if Alfa<270 then
  Repeat
    Alfa:=Alfa-90;
    begin
    sinAlfa:=i1;i1:= j1;j1:=SinAlfa;
    sinAlfa:=i2;i2:=j2;j2:=SinAlfa;
    i1:=-i1;i2:=-i2;
    end;
   Until Alfa<90
   else begin
         i1:= -i1;j2:=-j2;
        end;
  end;
end;

Procedure TDraw3D.SetSphereProjection(Alfa,Beta,ObserverDistance:Double;var ObserverPoint:T3DPoint);
var u,v                :TVector;
      SinAlfa,i,j,
      CosGamma,CosDelta,PomAlfa,PomBeta:Double;
      O,S,X,Y,Z          :T3DPoint;
begin
  ProjectionType:=ptSphere;
  ObserverPoint[1]:=ObserverDistance*cos(Alfa*pi/180)*cos(Beta*pi/180);
  ObserverPoint[2]:=ObserverDistance*sin(Alfa*pi/180)*cos(Beta*pi/180);
  ObserverPoint[3]:=ObserverDistance*sin(Beta*pi/180);
  PomAlfa:=Alfa;PomBeta:=Beta;
  if PomAlfa>90 then PomAlfa:=PomAlfa-90;
  if PomAlfa>90 then PomAlfa:=PomAlfa-90;
  PomAlfa:=Pi*PomAlfa/180;PomBeta:=pi*PomBeta/180;
  S[1]:=cos(PomAlfa)*cos(PomBeta);S[2]:=sin(PomAlfa)*cos(PomBeta);S[3]:=sin(PomBeta);
  O[1]:=0;O[2]:=0;O[3]:=0;
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  X[1]:=1/S[1];X[2]:=0;     X[3]:=0;
  Y[1]:=0;     Y[2]:=1/S[2];Y[3]:=0;
  Z[1]:=0;     Z[2]:=0;     Z[3]:=1/S[3];
  SetVector(S,X,u);SetVector(S,Z,v);
  CosGamma:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(S,Y,u);SetVector(S,Z,v);
  CosDelta:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(X,O,u);SetVector(X,S,v);
  i:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(Y,O,u);SetVector(Y,S,v);
  j:=ScalarProduct(u,v)/Norm(u)/Norm(v);
//  SetVector(Z,O,u);SetVector(Z,S,v);
  i1:=-i*sqrt(1-CosGamma*CosGamma);i2:=i*CosGamma;
  j1:=j*sqrt(1-CosDelta*CosDelta);j2:=j*CosDelta;
  k1:=0;                          k2:=cos(PomBeta);
  if Alfa>90 then
  begin
  S[1]:=cos(Alfa*pi/180)*cos(Beta*pi/180);S[2]:=sin(Alfa*pi/180)*cos(Beta*pi/180);S[3]:=sin(Beta*pi/180);
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  if Alfa<270 then
  Repeat
    Alfa:=Alfa-90;
    begin
    sinAlfa:=i1;i1:= j1;j1:=SinAlfa;
    sinAlfa:=i2;i2:=j2;j2:=SinAlfa;
    i1:=-i1;i2:=-i2;
    end;
   Until Alfa<90
   else begin
         i1:= -i1;j2:=-j2;
        end;
  end;
end;

procedure TDraw3D.SetDirectOfLight(AlfaLight,BetaLight:Double;var DirectOfLight:TVector);
begin
  DirectOfLight[1]:=cos(pi*AlfaLight/180)*cos(pi*BetaLight/180);
  DirectOfLight[2]:=sin(pi*AlfaLight/180)*cos(pi*BetaLight/180);
  DirectOfLight[3]:=sin(pi*BetaLight/180);
end;

 Procedure TDraw3D.SetVector(X,Y:T3DPoint;var v:TVector);
  begin
    v[1]:=Y[1]-X[1];
    v[2]:=Y[2]-X[2];
    v[3]:=Y[3]-X[3];
  end;

  Function TDraw3D.ScalarProduct(u,v:TVector):Double;
  begin
    ScalarProduct:=u[1]*v[1]+u[2]*v[2]+u[3]*v[3];
  end;

  Procedure TDraw3D.VectorProduct(r,s:TVector;var t:TVector);
  begin
   t[1]:= r[2]*s[3]-s[2]*r[3];
   t[2]:=-r[1]*s[3]+s[1]*r[3];
   t[3]:= r[1]*s[2]-s[1]*r[2];
  end;

  Function TDraw3D.Norm(u:TVector):Double;
  begin
    Norm:=Sqrt(u[1]*u[1]+u[2]*u[2]+u[3]*u[3]);
  end;

  function TDraw3D.CosAngle(r,s:TVector):Double;
  begin
    if (Norm(r)<1e-25) or (Norm(s)<1e-25)
     then CosAngle:=0
     else CosAngle:=ScalarProduct(r,s)/Norm(r)/Norm(s);
  end;

Procedure TDraw3D.PlaneIntersect(X:T3DPoint;var pX:T3DPoint);
var t:Double;
    Sm:TVector;
begin
  Sm:=MajorRay;
  t:=-Sm[1]*ObserverPoint[1]-Sm[2]*ObserverPoint[2]-Sm[3]*ObserverPoint[3];
  t:=t/(Sm[1]*(X[1]-ObserverPoint[1])+Sm[2]*(X[2]-ObserverPoint[2])+Sm[3]*(X[3]-ObserverPoint[3]));
  pX[1]:=ObserverPoint[1]+(X[1]-ObserverPoint[1])*t;
  pX[2]:=ObserverPoint[2]+(X[2]-ObserverPoint[2])*t;
  pX[3]:=ObserverPoint[3]+(X[3]-ObserverPoint[3])*t;
end;

Procedure TDraw3D.SphereIntersect(X:T3DPoint;var pX:T3DPoint);
var t:Double;
begin
  t:=sqrt(sqr(ObserverPoint[1])+sqr(ObserverPoint[2])+sqr(ObserverPoint[3]))-1;
  t:=t/sqrt(sqr(ObserverPoint[1]-x[1])+sqr(ObserverPoint[2]-x[2])+sqr(ObserverPoint[3]-x[3]));
  pX[1]:=ObserverPoint[1]+(X[1]-ObserverPoint[1])*t;
  pX[2]:=ObserverPoint[2]+(X[2]-ObserverPoint[2])*t;
  pX[3]:=ObserverPoint[3]+(X[3]-ObserverPoint[3])*t;
end;

Procedure  TDraw3D.Line(A,B:T3DPoint;Red,Green,Blue:Byte);
var  IntSectA,IntSectB:T3DPoint;
//*pidal Jakub Stodola
     AAAA             :T3DPoint;
//*
     pX,pY            :T2DPoint;
     X,Y              :TPixel;
     t                :Double;
//     i                :Integer;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin IntSectA:=A;IntSectB:=B;end;
       {stedov promtn na rovinu}
       2: begin PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);end;
    end;
    if ProjectionType<3
         then begin
              Projection(IntSectA,pX);Projection(IntSectB,pY);
              X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
              Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
              Line2D(X,Y,Red,Green,Blue);
              end
         else begin  {stedov promtn na kulovou plochu}
               t:=0;//i:=0;
                  AAAA[1] := A[1]+(B[1]-A[1])*t;
                  AAAA[2] := A[2]+(B[2]-A[2])*t;
                  AAAA[3] := A[3]+(B[3]-A[3])*t;
                  SphereIntersect(AAAA,IntSectA);
                  Projection(IntSectA,pY);
                  X[1]:=XCoor(pY[1]);X[2]:=YCoor(pY[2]);
               While t<=0.9 do
                 begin
                  t:=t+0.1;
             {    P[i,1]:=A[1]+(B[1]-A[1])*t;
                  P[i,2]:=A[2]+(B[2]-A[2])*t;
                  P[i,3]:=A[3]+(B[3]-A[3])*t;
                  SphereIntersect(P[i],Q[i]);
                  i:=succ(i);              }
                  AAAA[1] := A[1]+(B[1]-A[1])*t;
                  AAAA[2] := A[2]+(B[2]-A[2])*t;
                  AAAA[3] := A[3]+(B[3]-A[3])*t;
                  SphereIntersect(AAAA,IntSectA);
                  Projection(IntSectA,pY);
                    Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
                    Line2D(X,Y,Red,Green,Blue);
                    X := Y;
                 end;
//               PolyLine(Q,i,Red,Green,Blue)
              end;
 end;

procedure TDraw3D.PolyLine(X:TArrayOf3DPoints;n:Word;Red,Green,Blue:Byte);
 var i:Word;
 begin
   for i:=0 to n-2 do
     begin
      Line(X[i],X[succ(i)],Red,Green,Blue);
 {     TargetImage^.Repaint;}
     end; 
 end;

 Procedure TDraw3D.Put3DPoint(X:T3DPoint;Red,Green,Blue:Byte);
 var IntSectX                :T3DPoint;
     pX                      :T2DPoint;
     PixelX                  :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1:IntSectX:=X;
       {stedov promtn na rovinu}
       2:PlaneIntersect(X,IntSectX);
       {stedov promtn na kulovou plochu}
       3:SphereIntersect(X,IntSectX);
    end;
    Projection(IntSectX,pX);
    PixelX[1]:=XCoor(pX[1]);PixelX[2]:=YCoor(pX[2]);
    PutPixel(PixelX,Red,Green,Blue);
 end;

 Procedure TDraw3D.Cross(X:T3DPoint;Size,Red,Green,Blue:Byte);
 var IntSectX                :T3DPoint;
     pX                      :T2DPoint;
     PixelX,A,B,C,D          :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1:IntSectX:=X;
       {stedov promtn na rovinu}
       2:PlaneIntersect(X,IntSectX);
       {stedov promtn na kulovou plochu}
       3:SphereIntersect(X,IntSectX);
    end;
    Projection(IntSectX,pX);
    PixelX[1]:=XCoor(pX[1]);PixelX[2]:=YCoor(pX[2]);
    A[1]:=PixelX[1]-Size;A[2]:=PixelX[2];
    B[1]:=PixelX[1]+Size;B[2]:=PixelX[2];
    C[1]:=PixelX[1];     C[2]:=PixelX[2]-Size;
    D[1]:=PixelX[1];     D[2]:=PixelX[2]+Size;
    Line2D(A,B,Red,Green,Blue);
    Line2D(C,D,Red,Green,Blue);
end;

{procedure TDraw3D.Line(X,Y:T3DPoint;Red,Green,Blue:Byte);
var A,B  :TPixel;
  begin
     A[1]:=XCoor(X[1]);A[2]:=YCoor(X[2]);
     B[1]:=XCoor(Y[1]);B[2]:=YCoor(Y[2]);
     Line2D(A,B,Red,Green,Blue);
  end;}

 {Sestroj trojhelnk vyplnn zadanou barvou}
 procedure TDraw3D.FillTriangle(A,B,C:T3DPoint;Red,Green,Blue:byte);
 var IntSectA,IntSectB,IntSectC:T3DPoint;
     pX,pY,pZ                :T2DPoint;
     X,Y,Z                   :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin
           IntSectA:=A;IntSectB:=B;IntSectC:=C;
          end;
       {stedov promtn na rovinu}
       2: begin
            PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);PlaneIntersect(C,IntSectC);
          end;
       {stedov promtn na kulovou plochu}
       3: begin
            SphereIntersect(A,IntSectA);SphereIntersect(B,IntSectB);SphereIntersect(C,IntSectC);
          end;
    end;
    Projection(IntSectA,pX);Projection(IntSectB,pY);Projection(IntSectC,pZ);
    X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
    Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
    Z[1]:=XCoor(pZ[1]);Z[2]:=YCoor(pZ[2]);
    FillTriangle2D(X,Y,Z,Red,Green,Blue);
 end;

{Sestroj drsn trojhelnk vyplnn zadanou barvou}
 procedure TDraw3D.FillRoughTriangle(A,B,C:T3DPoint;Red,Green,Blue,Roughness:byte;ColorDisp:Boolean);
 var IntSectA,IntSectB,IntSectC:T3DPoint;
     pX,pY,pZ                :T2DPoint;
     X,Y,Z                   :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin
           IntSectA:=A;IntSectB:=B;IntSectC:=C;
          end;
       {stedov promtn na rovinu}
       2: begin
            PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);PlaneIntersect(C,IntSectC);
          end;
       {stedov promtn na kulovou plochu}
       3: begin
            SphereIntersect(A,IntSectA);SphereIntersect(B,IntSectB);SphereIntersect(C,IntSectC);
          end;
    end;
    Projection(IntSectA,pX);Projection(IntSectB,pY);Projection(IntSectC,pZ);
    X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
    Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
    Z[1]:=XCoor(pZ[1]);Z[2]:=YCoor(pZ[2]);
    FillRoughTriangle2D(X,Y,Z,Red,Green,Blue,Roughness,ColorDisp);
 end;

    {Sestroj prhledn trojhelnk vyplnn zadanou barvou}
 procedure TDraw3D.FillTranspTriangle(A,B,C:T3DPoint;Red,Green,Blue:byte;Transparency:Double);
 var IntSectA,IntSectB,IntSectC:T3DPoint;
     pX,pY,pZ                :T2DPoint;
     X,Y,Z                   :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin
           IntSectA:=A;IntSectB:=B;IntSectC:=C;
          end;
       {stedov promtn na rovinu}
       2: begin
            PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);PlaneIntersect(C,IntSectC);
          end;
       {stedov promtn na kulovou plochu}
       3: begin
            SphereIntersect(A,IntSectA);SphereIntersect(B,IntSectB);SphereIntersect(C,IntSectC);
          end;
    end;
    Projection(IntSectA,pX);Projection(IntSectB,pY);Projection(IntSectC,pZ);
    X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
    Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
    Z[1]:=XCoor(pZ[1]);Z[2]:=YCoor(pZ[2]);
    FillTranspTriangle2D(X,Y,Z,Red,Green,Blue,Transparency);
 end;

 {Sestroj trojhelnk vyplnn interpolac barvy ve vrcholech}
 procedure TDraw3D.FillInterpolTriangle(A,B,C:T3DPoint;RedA,GreenA,BlueA,
                                                    RedB,GreenB,BlueB,
                                                    RedC,GreenC,BlueC:byte);
 var IntSectA,IntSectB,IntSectC:T3DPoint;
     pX,pY,pZ                :T2DPoint;
     X,Y,Z                   :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin
           IntSectA:=A;IntSectB:=B;IntSectC:=C;
          end;
       {stedov promtn na rovinu}
       2: begin
            PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);PlaneIntersect(C,IntSectC);
          end;
       {stedov promtn na kulovou plochu}
       3: begin
            SphereIntersect(A,IntSectA);SphereIntersect(B,IntSectB);SphereIntersect(C,IntSectC);
          end;
    end;
    Projection(IntSectA,pX);Projection(IntSectB,pY);Projection(IntSectC,pZ);
    X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
    Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
    Z[1]:=XCoor(pZ[1]);Z[2]:=YCoor(pZ[2]);
    FillInterpolTriangle2D(X,Y,Z,RedA,GreenA,BlueA,RedB,GreenB,BlueB,RedC,GreenC,BlueC);
 end;

 {Sestroj prhledn trojhelnk vyplnn interpolac barvy ve vrcholech}
 procedure TDraw3D.FillInterpolTranspTriangle
                        (A,B,C:T3DPoint;RedA,GreenA,BlueA,
                                        RedB,GreenB,BlueB,
                                        RedC,GreenC,BlueC:byte;Transparency:Double);
 var IntSectA,IntSectB,IntSectC:T3DPoint;
     pX,pY,pZ                :T2DPoint;
     X,Y,Z                   :TPixel;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin
           IntSectA:=A;IntSectB:=B;IntSectC:=C;
          end;
       {stedov promtn na rovinu}
       2: begin
            PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);PlaneIntersect(C,IntSectC);
          end;
       {stedov promtn na kulovou plochu}
       3: begin
            SphereIntersect(A,IntSectA);SphereIntersect(B,IntSectB);SphereIntersect(C,IntSectC);
          end;
    end;
    Projection(IntSectA,pX);Projection(IntSectB,pY);Projection(IntSectC,pZ);
    X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
    Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
    Z[1]:=XCoor(pZ[1]);Z[2]:=YCoor(pZ[2]);
    FillInterpolTranspTriangle2D(X,Y,Z,RedA,GreenA,BlueA,RedB,GreenB,BlueB,
                                       RedC,GreenC,BlueC,Transparency);
 end;

(* Procedure TDraw3D.XAxis(x1,x2,y:Double;Red,Green,Blue:Byte);
 begin
    A[1]:=x1;A[2]:=y;B[1]:=x2;B[2]:=A[2];
    cvLine(A,B,Red,Green,Blue);
 end;

Procedure TDraw3D.YAxis(y1,y2,x:Double;Red,Green,Blue:Byte);
  begin
    A[1]:=x;A[2]:=y1;B[1]:=A[1];B[2]:=y2;
    cvLine(A,B,Red,Green,Blue);
  end;

procedure TDraw3D.GaugedXAxis(x1,x2,y:Double;Red,Green,Blue:Byte);
  var  AxisUnit        :Double;
       Text            :String;
       Lx,Exponent     :Integer;

   begin
   XAxis(x1,x2,y,Red,Green,Blue);
   TargetImage^.Canvas.Font.Color:=Red+256*Green+256*256*Blue;
   TargetImage^.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
   AxisUnit:=1E30;Lx:=0;Exponent:=30;
   While (x2-x1)/AxisUnit<3 do
    begin
       AxisUnit:=AxisUnit/10;Exponent:=Exponent-1;
    end;
   Lx:=0;
   if x1<0 then
     Repeat Lx:=Lx-1 Until AxisUnit*(Lx-1)<x1
           else
     Repeat Lx:=Lx+1 Until AxisUnit*(Lx+1)>x1;
   With TargetImage^.Canvas do
   repeat
      MoveTo(XCoor(AxisUnit*Lx),YCoor(y)-3);
      LineTo(XCoor(AxisUnit*Lx),YCoor(y)+3);
      Str(Lx,Text);
      TextOut(XCoor(AxisUnit*Lx)+3,YCoor(y)+5,Text);
      Lx:=Lx+1;
   until AxisUnit*(Lx+1)>x2;
   Str(Exponent,Text);
   TargetImage^.Canvas.Brush.Color:=clWhite;
  { TargetImage^.Canvas.TextOut(XCoor(x2)-40,YCoor(y)+5,'    ');}
   TargetImage^.Canvas.TextOut(XCoor(x2)-40,YCoor(y)+5,'*10');
   TargetImage^.Canvas.TextOut(XCoor(x2)-20,YCoor(Y)+1,Text);
   end;

procedure TDraw3D.GaugedYAxis(y1,y2,x:Double;Red,Green,Blue:Byte);
   var AxisUnit        :Double;
       Text            :String;
       Ly,Exponent     :Integer;
   begin
   YAxis(y1,y2,x,Red,Green,Blue);
   TargetImage^.Canvas.Font.Color:=Red+256*Green+256*256*Blue;
   TargetImage^.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
   AxisUnit:=1E30;Ly:=0;Exponent:=30;
   While (y2-y1)/AxisUnit<3 do
    begin
       AxisUnit:=AxisUnit/10;Exponent:=Exponent-1;
    end;
   Ly:=0;
   if y1<0 then
     Repeat Ly:=Ly-1 Until AxisUnit*(Ly-1)<y1
           else
     Repeat Ly:=Ly+1 Until AxisUnit*(Ly+1)>y1;
   With TargetImage^.Canvas do
   repeat
      MoveTo(XCoor(x)-3,YCoor(AxisUnit*Ly));
      LineTo(XCoor(x)+3,YCoor(AxisUnit*Ly));
      Str(Ly,Text);
      TextOut(XCoor(x)-25,YCoor(AxisUnit*Ly)-15,Text);
      Ly:=Ly+1;
   until AxisUnit*(Ly+1)>y2;
   Str(Exponent,Text);
   TargetImage^.Canvas.TextOut(XCoor(x)+5,YCoor(y2)+10,'    ');
   TargetImage^.Canvas.TextOut(XCoor(x)+5,YCoor(y2)+10,'*10');
   TargetImage^.Canvas.TextOut(XCoor(x)+25,YCoor(y2)+3,Text);
   end; *)

 Procedure TDraw3D.Triangle(A,B,C:T3DPoint;Red,Green,Blue:Byte);
 begin
   Line(A,B,Red,Green,Blue);
   Line(B,C,Red,Green,Blue);
   Line(C,A,Red,Green,Blue);
 end;

procedure TDraw3D.cvLine(A,B:T3DPoint;Red,Green,Blue:byte);
var  IntSectA,IntSectB:T3DPoint;
     pX,pY            :T2DPoint;
     X,Y              :TPixel;
     t                :Double;
     i{,j}              :Integer;
 begin
   Case ProjectionType of
       {axonometrie}
       0,1: begin IntSectA:=A;IntSectB:=B;end;
       {stedov promtn na rovinu}
       2: begin PlaneIntersect(A,IntSectA);PlaneIntersect(B,IntSectB);end;
    end;
      if ProjectionType<3
         then begin
              Projection(IntSectA,pX);Projection(IntSectB,pY);
              X[1]:=XCoor(pX[1]);X[2]:=YCoor(pX[2]);
              Y[1]:=XCoor(pY[1]);Y[2]:=YCoor(pY[2]);
              With TargetImage^.Canvas do
                begin
                  Pen.Color:=Red+256*Green+256*256*Blue;
                  MoveTo(X[1],X[2]);
                  LineTo(Y[1],Y[2]);
                end;
              end
         else begin  {stedov promtn na kulovou plochu}
               t:=0;i:=0;
               While t<=1.05 do
                 begin
                  P[i,1]:=A[1]+(B[1]-A[1])*t;
                  P[i,2]:=A[2]+(B[2]-A[2])*t;
                  P[i,3]:=A[3]+(B[3]-A[3])*t;
                  SphereIntersect(P[i],Q[i]);
                  i:=succ(i);t:=t+0.05;
                 end;
               Projection(Q[0],pX);TargetImage^.Canvas.Pen.Color:=Red+256*Green+256*256*Blue;
               TargetImage^.Canvas.MoveTo(XCoor(pX[1]),YCoor(pX[2]));
               for i:=1 to i-1 do
                  begin
                    Projection(Q[i],pX);
                    TargetImage^.Canvas.LineTo(XCoor(pX[1]),YCoor(pX[2]));
                  end;
              end;
end;

procedure TDraw3D.cvPolyLine(X:TArrayOf3DPoints;n:Word;Red,Green,Blue:byte);
var i:Word;
begin
  {  With TargetImage^.Canvas do
     begin
       Pen.Color:=Red+256*Green+256*256*Blue;
       MoveTo(XCoor(X[0,1]),YCoor(X[0,2]));
       for i:=1 to n-1 do
         LineTo(XCoor(X[i,1]),YCoor(X[i,2]));
    end;}
    for i:=0 to n-2 do cvLine(X[i],X[succ(i)],Red,Green,Blue);
end;

procedure TDraw3D.cvBox(Box:TBox;Red,Green,Blue:byte);
begin
 With Box do
 begin
  cvLine(A,B,Red,Green,Blue);cvLine(B,C,Red,Green,Blue);
  cvLine(C,D,Red,Green,Blue);cvLine(D,A,Red,Green,Blue);
  cvLine(Ac,Bc,Red,Green,Blue);cvLine(Bc,Cc,Red,Green,Blue);
  cvLine(Cc,Dc,Red,Green,Blue);cvLine(Dc,Ac,Red,Green,Blue);
  cvLine(A,Ac,Red,Green,Blue);cvLine(B,Bc,Red,Green,Blue);
  cvLine(C,Cc,Red,Green,Blue);cvLine(D,Dc,Red,Green,Blue);
 end;
end;

procedure TDraw3D.TransOfPoint(X:T3DPoint;Z:TMatrix;var Xc:T3DPoint);
   var i,j:Byte;
   begin
      for i:=1 to 4 do Xc[i]:=0;
      for j:=1 to 4 do
       for i:=1 to 4 do
           Xc[j]:=Xc[j]+X[i]*Z[i,j];
   end;

   Procedure TDraw3D.TransOfTriangle(A,B,C:T3DPoint;Z:TMatrix;
                 var Ac,Bc,Cc:T3DPoint);
   begin
      TransOfPoint(A,Z,Ac);
      TransOfPoint(B,Z,Bc);
      TransOfPoint(C,Z,Cc);
   end;

Procedure TDraw3D.TransOfBox(Box1:TBox;Z:TMatrix;var Box2:TBox);
   begin
      TransOfPoint(Box1.A,Z,Box2.A);
      TransOfPoint(Box1.B,Z,Box2.B);
      TransOfPoint(Box1.C,Z,Box2.C);
      TransOfPoint(Box1.D,Z,Box2.D);
      TransOfPoint(Box1.Ac,Z,Box2.Ac);
      TransOfPoint(Box1.Bc,Z,Box2.Bc);
      TransOfPoint(Box1.Cc,Z,Box2.Cc);
      TransOfPoint(Box1.Dc,Z,Box2.Dc);
   end;

Procedure TDraw3D.Multip(M,N:TMatrix;var Result:TMatrix);
Var i,j,k:Integer;
begin
    for i:=1 to 4 do for j:=1 to 4 do Result[i,j]:=0;
    for i:=1 to 4 do for k:=1 to 4 do for j:=1 to 4 do
                      Result[i,j]:=Result[i,j]+M[i,k]*N[k,j];
end;

procedure TDraw3D.Transl(v:TVector;var M:TMatrix);
begin
  M[1,1]:=1;   M[1,2]:=0;   M[1,3]:=0;   M[1,4]:=0;
  M[2,1]:=0;   M[2,2]:=1;   M[2,3]:=0;   M[2,4]:=0;
  M[3,1]:=0;   M[3,2]:=0;   M[3,3]:=1;   M[3,4]:=0;
  M[4,1]:=v[1];M[4,2]:=v[2];M[4,3]:=v[3];M[4,4]:=1;
end;

procedure TDraw3D.RotX(Alfa:Double;var M:TMatrix);
begin
  M[1,1]:=1;M[1,2]:= 0;        M[1,3]:=0;        M[1,4]:=0;
  M[2,1]:=0;M[2,2]:= cos(Alfa);M[2,3]:=sin(Alfa);M[2,4]:=0;
  M[3,1]:=0;M[3,2]:=-sin(alfa);M[3,3]:=cos(Alfa);M[3,4]:=0;
  M[4,1]:=0;M[4,2]:= 0;        M[4,3]:=0;        M[4,4]:=1;
end;

procedure TDraw3D.RotY(Beta:Double;var M:TMatrix);
begin
  M[1,1]:= cos(Beta);M[1,2]:=0;M[1,3]:=sin(Beta);M[1,4]:=0;
  M[2,1]:= 0;        M[2,2]:=1;M[2,3]:=0;        M[2,4]:=0;
  M[3,1]:=-sin(Beta);M[3,2]:=0;M[3,3]:=cos(Beta);M[3,4]:=0;
  M[4,1]:= 0;        M[4,2]:=0;M[4,3]:=0;        M[4,4]:=1;
end;

procedure TDraw3D.RotZ(Gamma:Double;var M:TMatrix);
begin
  M[1,1]:= cos(Gamma);M[1,2]:=sin(Gamma);M[1,3]:=0;M[1,4]:=0;
  M[2,1]:=-sin(Gamma);M[2,2]:=cos(Gamma);M[2,3]:=0;M[2,4]:=0;
  M[3,1]:= 0;         M[3,2]:=0;         M[3,3]:=1;M[3,4]:=0;
  M[4,1]:= 0;         M[4,2]:=0;         M[4,3]:=0;M[4,4]:=1;
end;

procedure TDraw3D.AxisSymX(var M:TMatrix);
begin
  M[1,1]:=1;M[1,2]:= 0;M[1,3]:= 0;M[1,4]:=0;
  M[2,1]:=0;M[2,2]:=-1;M[2,3]:= 0;M[2,4]:=0;
  M[3,1]:=0;M[3,2]:= 0;M[3,3]:=-1;M[3,4]:=0;
  M[4,1]:=0;M[1,2]:= 0;M[1,3]:= 0;M[1,4]:=1;
end;

procedure TDraw3D.AxisSymY(var M:TMatrix);
begin
  M[1,1]:=-1;M[1,2]:=0;M[1,3]:= 0;M[1,4]:=0;
  M[2,1]:= 0;M[2,2]:=1;M[2,3]:= 0;M[2,4]:=0;
  M[3,1]:= 0;M[3,2]:=0;M[3,3]:=-1;M[3,4]:=0;
  M[4,1]:= 0;M[1,2]:=0;M[1,3]:= 0;M[1,4]:=1;
end;

procedure TDraw3D.AxisSymZ(var M:TMatrix);
begin
  M[1,1]:=-1;M[1,2]:= 0;M[1,3]:=0;M[1,4]:=0;
  M[2,1]:= 0;M[2,2]:=-1;M[2,3]:=0;M[2,4]:=0;
  M[3,1]:= 0;M[3,2]:= 0;M[3,3]:=1;M[3,4]:=0;
  M[4,1]:= 0;M[1,2]:= 0;M[1,3]:=0;M[1,4]:=1;
end;

procedure TDraw3D.PlaneSymXY(var M:TMatrix);
begin
  M[1,1]:=1;M[1,2]:=0;M[1,3]:= 0;M[1,4]:=0;
  M[2,1]:=0;M[2,2]:=1;M[2,3]:= 0;M[2,4]:=0;
  M[3,1]:=0;M[3,2]:=0;M[3,3]:=-1;M[3,4]:=0;
  M[4,1]:=0;M[1,2]:=0;M[1,3]:= 0;M[1,4]:=1;
end;

procedure TDraw3D.PlaneSymXZ(var M:TMatrix);
begin
  M[1,1]:=1;M[1,2]:= 0;M[1,3]:=0;M[1,4]:=0;
  M[2,1]:=0;M[2,2]:=-1;M[2,3]:=0;M[2,4]:=0;
  M[3,1]:=0;M[3,2]:= 0;M[3,3]:=1;M[3,4]:=0;
  M[4,1]:=0;M[1,2]:= 0;M[1,3]:=0;M[1,4]:=1;
end;

procedure TDraw3D.PlaneSymYZ(var M:TMatrix);
begin
  M[1,1]:=-1;M[1,2]:=0;M[1,3]:=0;M[1,4]:=0;
  M[2,1]:= 0;M[2,2]:=1;M[2,3]:=0;M[2,4]:=0;
  M[3,1]:= 0;M[3,2]:=0;M[3,3]:=1;M[3,4]:=0;
  M[4,1]:= 0;M[1,2]:=0;M[1,3]:=0;M[1,4]:=1;
end;

procedure TDraw3D.OriginSym(var M:TMatrix);
begin
  M[1,1]:=-1;M[1,2]:= 0;M[1,3]:= 0;M[1,4]:=0;
  M[2,1]:= 0;M[2,2]:=-1;M[2,3]:= 0;M[2,4]:=0;
  M[3,1]:= 0;M[3,2]:= 0;M[3,3]:=-1;M[3,4]:=0;
  M[4,1]:= 0;M[1,2]:= 0;M[1,3]:= 0;M[1,4]:=1;
end;

procedure TDraw3D.GenRot(A,B:T3DPoint;Alfa:Double;var M:TMatrix);
var Mat1,Mat2,Mat       :TMatrix;
    V                   :TVector;
//    i                   :Integer;
    Beta,Gama           :Real;
begin
    V[1]:=-A[1];V[2]:=-A[2];V[3]:=-A[3];
    Transl(V,Mat1);
    Beta:=-Arctan((B[2]-A[2])/(B[1]-A[1]));
    RotZ(Beta,Mat2);
    Multip(Mat1,Mat2,Mat);
    Mat1:=Mat;
    Gama:=Arctan(sqrt(sqr(B[1]-A[1])+sqr(B[2]-A[2]))/(B[3]-A[3]));
    RotY(Gama,Mat2);
    Multip(Mat1,Mat2,Mat);
    Mat1:=Mat;
    RotZ(Alfa,Mat2);
    Multip(Mat1,Mat2,Mat);
    Mat1:=Mat;
    Gama:=-Gama;
    RotY(Gama,Mat2);
    Multip(Mat1,Mat2,Mat);
    Mat1:=Mat;
    Beta:=-Beta;
    RotZ(Beta,Mat2);
    Multip(Mat1,Mat2,Mat);
    Mat1:=Mat;
    V[1]:=-V[1];V[2]:=-V[2];V[3]:=-V[3];
    Transl(V,Mat2);
    Multip(Mat1,Mat2,Mat);
    M:=Mat;
end;

{***** pridal J. Stodola *****}
// kvuli pozici mysi
// inverze PlaneIntersect
procedure TDraw3D.InvPlaneIntersect(ipX: T3DPoint; zc: Double ; var X: T3DPoint);
var t {, zc} :Double;
begin
//  zc:=0;
  t:=(zc-ObserverPoint[3])
      /(ipX[3]-ObserverPoint[3]);
  X[1]:=ObserverPoint[1]+(ipX[1]-ObserverPoint[1])*t;
  X[2]:=ObserverPoint[2]+(ipX[2]-ObserverPoint[2])*t;
  X[3]:=zc;
//  X[3]:=ObserverPoint[3]+(ipX[3]-ObserverPoint[3])*t;
  moX:=X[1];
  moY:=X[2];
//moZ:=X[3];
end;
procedure TDraw3D.InvProjection(pX: T2DPoint;var ipX: T3DPoint);
var
    L: T33Matrix;
    b: TVector;
begin
    L[1,1]:=i1;L[1,2]:=j1;L[1,3]:=k1;   //k1 je stejn 0
    L[2,1]:=i2;L[2,2]:=j2;L[2,3]:=k2;
    L[3,1]:=MajorRay[1];L[3,2]:=MajorRay[2];L[3,3]:=MajorRay[3];
    b[1]:=pX[1];b[2]:=pX[2];b[3]:=0;
   (* if Nastaveni.RadioButton2.Checked then b[3]:=0
                                       else b[3]:=1; *)
    Solve33GEM(L,b,ipX);
end;
procedure TDraw3D.InvSphereProjection(pX: T2DPoint;var ipX: T3DPoint);
var ispG, ispQ, ispM, ispN,
    kvrcA, kvrcB, kvrcC, kvrcD,
    radius                        : double;
    i: integer;
begin
//predpokladame k1 = 0
ispM:= -i1/j1;
ispN:= -pX[1]/j1;

ispG:= (-i2 - ispM*j2)/k2;
ispQ:= (-pX[2] - ispN*j2)/k2;

radius:= ObserverDistance - 1;

ispN:= ispN + ObserverPoint[2];
ispQ:= ispQ + ObserverPoint[3];

kvrcA:= 1 + ispM*ispM + ispG*ispG;
kvrcB:= -2*( ObserverPoint[1] + ispM*ispN + ispG*ispQ );
kvrcC:= ObserverPoint[1]*ObserverPoint[1] + ispN*ispN +ispQ*ispQ - radius*radius;

ispN:= ispN - ObserverPoint[2];
ispQ:= ispQ - ObserverPoint[3];

kvrcD:= kvrcB*kvrcB - 4*kvrcA*kvrcC;
if kvrcD >= 0 then begin
ipX[1]:= (-kvrcB - sqrt(kvrcD)) / 2 / kvrcA; //-, Ob een by mla bt kladn.
                               //Hledme to ble k potku soustavy souadnic
ipX[2]:= ipX[1]*ispM - ispN;
ipX[3]:= ipX[1]*ispG - ispQ;
end else begin
for i:= 1 to 3 do
ipX[i]:=MajorRay[i];
end;

end;

procedure TDraw3D.Solve33GEM(A: T33Matrix; b: TVector; var X: T3DPoint);
var i,j,k: integer;
begin
  for k:=1 to 2 do
    for i:=k+1 to 3 do
    begin
        A[i,k]:=A[i,k]/A[k,k];
        for j:=k+1 to 3 do A[i,j]:=A[i,j]-A[i,k]*A[k,j];
        b[i]:=b[i]-A[i,k]*b[k];
    end;
  X[3]:=b[3]/A[3,3];
  X[2]:=(b[2]-A[2,3]*X[3])/A[2,2];
  X[1]:=(b[1]-A[1,3]*X[3]-A[1,2]*X[2])/A[1,1];
end;
//pozice mysi
procedure TDraw3D.ImageMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
var  moXstr,moYstr,moZstr: string;
     InvPoint,moPointShow: T3DPoint;
     moPoint: T2DPoint;
//     moZ: Double;
     moZPlaneA,moZPlaneB,moZPlaneC,moZPlaneD: T3DPoint;
     i: integer;
     increm,incremPuv: double;
begin
    moZ:=moZrem;
    If ssCtrl in Shift then begin
     if SetCurrentDir(ExtractFilePath(ParamStr(0))+'/temp_images') then begin
        Image.Picture.LoadFromFile('temp.bmp');
     end;
     (*     if SideViews then begin
            Image1.Picture.LoadFromFile('temp1.bmp');
            Image2.Picture.LoadFromFile('temp2.bmp');
            Image3.Picture.LoadFromFile('temp3.bmp');
          end; *)
        moZ:= (-Y+O[2])/Unit_Y;
        moZrem:=moZ;
        //zobrazen z-roviny
          incremPuv:=(x2-x1)/16;
          moZPlaneA[1]:=0{moX};moZPlaneA[2]:=0{moY};moZPlaneA[3]:=moZ;
        for i:= -4 to 4 do begin
        //  i:=1;
          increm := incremPuv*i;
 //         moZPlaneA[1]:=moX+increm;moZPlaneA[2]:={moY+}increm;moZPlaneA[3]:=moZ;
          moZPlaneB[1]:={moX+}increm;moZPlaneB[2]:=0{moY};moZPlaneB[3]:=moZ;
          moZPlaneC[1]:={moX+}increm;moZPlaneC[2]:={moY+}increm;moZPlaneC[3]:=moZ;
          moZPlaneD[1]:=0{moX};moZPlaneD[2]:={moY+}increm;moZPlaneD[3]:=moZ;
          Line(moZPlaneA,moZPlaneB,0,255,0);
          Line(moZPlaneB,moZPlaneC,0,255,0);
          Line(moZPlaneC,moZPlaneD,0,255,0);
          Line(moZPlaneD,moZPlaneA,0,255,0);
                    moZPlaneB[1]:={moX}-increm;moZPlaneB[2]:=0{moY};moZPlaneB[3]:=moZ;
          moZPlaneC[1]:={moX}-increm;moZPlaneC[2]:={moY+}increm;moZPlaneC[3]:=moZ;
          moZPlaneD[1]:=0{moX};moZPlaneD[2]:={moY+}increm;moZPlaneD[3]:=moZ;
          Line(moZPlaneA,moZPlaneB,0,255,0);
          Line(moZPlaneB,moZPlaneC,0,255,0);
          Line(moZPlaneC,moZPlaneD,0,255,0);
          Line(moZPlaneD,moZPlaneA,0,255,0);
        end;
        Image.Repaint;
    end;
          moPoint[1]:= (X-O[1])/Unit_X;
          moPoint[2]:= (-Y+O[2])/Unit_Y;
   Case ProjectionType of
       {axonometrie}
       0,1: begin
               //  moPoint[1]:= moPoint[1];//-k1*moZ; //k1 je stejn 0
                 moPoint[2]:= moPoint[2]-k2*moZ;
                 InvPoint[1]:= (j2*moPoint[1]-j1*moPoint[2])/(i1*j2-j1*i2);
                 InvPoint[2]:= (i2*moPoint[1]-i1*moPoint[2])/(j1*i2-i1*j2);
                 InvPoint[3]:= moZ;
                 moPointShow:=InvPoint;
                 moX:=moPointShow[1];
                 moY:=moPointShow[2];
            end;
       {stedov promtn na rovinu}
       2: begin
                InvProjection(moPoint,InvPoint);
                InvPlaneIntersect(InvPoint,moZ,moPointShow);
          end;
       {stedov promtn na kulovou plochu}
       3: begin
                InvSphereProjection(moPoint,InvPoint);
                InvPlaneIntersect(InvPoint,moZ,moPointShow);
          end;
    end;
    Str(moPointShow[1]:1:4,moXstr);
    Str(moPointShow[2]:1:4,moYstr);
    Str(moPointShow[3]:1:4,moZstr);
    LabelMouse.Caption:='mouse X: '+ moXstr + ' mouse Y: '+ moYstr + ' mouse Z: ' + moZstr;
    Draw3D.Caption := LabelMouse.Caption;
          if SideViews then begin
           if SetCurrentDir(ExtractFilePath(ParamStr(0))+'/temp_images') then begin
            TargetImage := @Image1;
            Nastaveni.Set_Projection;
            Image1.Picture.LoadFromFile('temp1.bmp');
            Cross(moPointShow,3,0,255,0);
            TargetImage^.Repaint;

            TargetImage := @Image2;
            Nastaveni.Set_Projection;
            Image2.Picture.LoadFromFile('temp2.bmp');
            Cross(moPointShow,3,0,255,0);
            TargetImage^.Repaint;

            TargetImage := @Image3;
            Nastaveni.Set_Projection;
            Image3.Picture.LoadFromFile('temp3.bmp');
            Cross(moPointShow,3,0,255,0);
            TargetImage^.Repaint;

            TargetImage := @Image;
            Nastaveni.Set_Projection;
            Image.Picture.LoadFromFile('temp.bmp');
           end;
          end;
end;

procedure TDraw3D.FormCreate(Sender: TObject);
begin
TargetImage:= @Image;
zadavani := 0;
moX:=0;moY:=0;moZ:=0;
moZrem:=0;
//moY:=0;
//InitMemoryImage(510,510);
end;
procedure TDraw3D.ImageClick(Sender: TObject);
var Pp: T3DPoint;
begin
  if zadavani >= 1 then begin
    Pp[1]:=moX;
    Pp[2]:=moY;
    Pp[3]:=moZ;
    TargetImage:=@Image;
    Cross(Pp,5,0,255,0);
    TargetImage^.Repaint;
      if SideViews then begin
            TargetImage:=@Image1;
            Cross(Pp,3,0,255,0);
            TargetImage^.Repaint;
            TargetImage:=@Image2;
            Cross(Pp,3,0,255,0);
            TargetImage^.Repaint;
            TargetImage:=@Image3;
            Cross(Pp,3,0,255,0);
            TargetImage^.Repaint;
            TargetImage:=@Image;
      end;
    ControlPointTable.ZadatBod(Pp);
    zadavani := zadavani - 1;
  end;
end;

Procedure TDraw3D.Set_TargetImage;
begin
//      TargetImage := @Image;
//      Nastaveni.Butt2Click;
  if Nastaveni.CheckBoxSideLooks.Checked then
  begin
      SideViews := true;
      TargetImage := @Image1;
      Nastaveni.Butt2Click;
      TargetImage := @Image2;
      Nastaveni.Butt2Click;
      TargetImage := @Image3;
      Nastaveni.Butt2Click;
  end else SideViews := false;
      TargetImage := @Image;
      Nastaveni.Butt2Click;      
end;

procedure TDraw3D.SpinEdit1Change(Sender: TObject);
//var vypis: string;
begin
    Nastaveni.EditBeta.Text:= IntToStr(Draw3D.SpinEdit1.Value);
    If CheckBoxAutoref.Checked then begin
    Nastaveni.Button2.Click;
    end;
end;

procedure TDraw3D.SpinEdit2Change(Sender: TObject);
begin
    Nastaveni.EditAlfa.Text:= IntToStr(Draw3D.SpinEdit2.Value);
    If CheckBoxAutoref.Checked then begin
    Nastaveni.Button2.Click;
    end;
end;

procedure TDraw3D.ScrollBar1Change(Sender: TObject);
begin
    If CheckBoxAutoref.Checked then begin
      Nastaveni.Button2.Click;
    end;
end;

procedure TDraw3D.ButtonRefreshClick(Sender: TObject);
begin
    Nastaveni.Button2.Click;
end;
{***** ----------------- *****}

end.
